/**
 * BladeX Commercial License Agreement
 * Copyright (c) 2018-2099, https://bladex.cn. All rights reserved.
 * <p>
 * Use of this software is governed by the Commercial License Agreement
 * obtained after purchasing a license from BladeX.
 * <p>
 * 1. This software is for development use only under a valid license
 * from BladeX.
 * <p>
 * 2. Redistribution of this software's source code to any third party
 * without a commercial license is strictly prohibited.
 * <p>
 * 3. Licensees may copyright their own code but cannot use segments
 * from this software for such purposes. Copyright of this software
 * remains with BladeX.
 * <p>
 * Using this software signifies agreement to this License, and the software
 * must not be used for illegal purposes.
 * <p>
 * THIS SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY. The author is
 * not liable for any claims arising from secondary or illegal development.
 * <p>
 * Author: Chill Zhuang (bladejava@qq.com)
 */
package org.springblade.modules.fitting.service;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.extension.service.IService;
import org.springblade.core.tool.api.R;
import org.springblade.modules.fitting.pojo.dto.BhMaterialDTO;
import org.springblade.modules.fitting.pojo.dto.ApplyDto;
import org.springblade.modules.fitting.pojo.entity.PlatformFittingApplyEntity;
import org.springblade.modules.fitting.pojo.vo.*;
import org.springblade.modules.fitting.excel.PlatformFittingApplyExcel;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.core.mp.base.BaseService;

import java.util.List;
import java.util.Map;

/**
 * 服务商向平台备件申请领用记录表 服务类
 *
 * @author lzp
 * @since 2024-08-24
 */
public interface IPlatformFittingApplyService extends IService<PlatformFittingApplyEntity> {
	/**
	 * 自定义分页
	 *
	 * @param page
	 * @param platformFittingApply
	 * @return
	 */
	IPage<PlatformFittingApplyEntity> selectPlatformFittingApplyPage(IPage<PlatformFittingApplyEntity> page, PlatformFittingApplyVO platformFittingApply);


	/**
	 * 导出数据
	 *
	 * @param queryWrapper
	 * @return
	 */
	List<PlatformFittingApplyExcel> exportPlatformFittingApply(Wrapper<PlatformFittingApplyEntity> queryWrapper);

	/**
	 * 平台审核
	*/
	 boolean toExamine(String id ,String remarks,String type,String examineType);

	 //新增物料申请
	 boolean saveFittingApply(AddFittingApplyVo addFittingApplyVo);

	//编辑物料申请
	boolean editFittingApply(AddFittingApplyVo addFittingApplyVo);

	boolean siteToExamine(SiteToExamineVo vo);

	boolean fittingBh(AddBhVo addBhVo);

	boolean editFittingBh(OperaAddFittingBatchVo batchVo);

	FittingApplyDetailVo getFittingApplyDetailById(String id);


	List<String> getMaterialSpecList(String materialType);

	//删除申请的物料
	boolean deleteApplyFitting(String id);

	boolean sendOutGoods(Map<String,Object> maps);

    List<BhMaterialDTO> getMaterialListByCodeOrName(ChooseMaterialListVo conditonVo);
	boolean siteSignFor(String id);

	boolean siteOutbound(String id);

	boolean empReceiveMate(String id);

	ApplyDto findHomeFittingCount();

	List<OperationOrderMaterialVO> auditFittingMatchingMaterial(Map<String, Object> params);

}
